%{
#include <stdio.h>
#include <string.h>

char* buf;
int bufsize;
int buffill;
int bytenum = 0;

int complementary(char a, char b) {
  return a=='c' && b=='g' || 
	 a=='g' && b=='c' || 
         a=='a' && b=='u' || 
         a=='u' && b=='a';
}

int energy(char a, char b) {
  return complementary(a,b)*((a=='c' || b=='c')+1)*2;
}

int lmerenergy(char* lmer) {
  int ensum = 0, len = strlen(lmer);
  int midlen = (len-1)/2;
  int k;

  for (k=0; k<=midlen; k++) {
       ensum += energy(lmer[k], lmer[len-k-1]);
  }
  return ensum;
}

%}
%x dane
%%
[acgu] { if (buffill==bufsize) memmove(buf, buf+1, bufsize-1); else buffill++; buf[buffill-1] = yytext[0]; printf("%3d %s %d\n", bytenum, buf, lmerenergy(buf)); bytenum++; }
.      { ; }
\n     { ; }
%%
int yywrap(void) { return 1; };
int main(int argc, char** argv) { 
  buffill = 0;
  if (argc<2) {
    printf("usage: %s bufsize\n", argv[0]);
    return 1;
  }

  bufsize = atoi(argv[1]);
  if (bufsize == 0) {
    printf("buffer size can't be zero\n");
    return 1;
  }

  buf = malloc(bufsize+1); // plus one for NULL to terminate string
  bzero(buf, bufsize+1);

  yylex();
  for (buffill=0; buffill<bufsize; buffill++) {
       printf("%3d %s %d\n", bytenum, buf+buffill, lmerenergy(buf+buffill));
       bytenum++;
  }
  return 0;
}; 
