%{
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include "gramtree.c"
  int yylex(void);
  void yyerror(const char *,...);
  int yyparse(void);

  node* root = NULL;
%}
%union
{
  struct node *n;
  char* seq;
}
%token <n> OPENID CLOSEID LBRACKET RBRACKET
%token <seq> SEQUENCE
%type <n> S TOKEN_LIST TOKEN CMPLTRY OPEN CLOSE
%%
S : LBRACKET TOKEN_LIST RBRACKET
;

TOKEN_LIST : TOKEN_LIST TOKEN 
| TOKEN
;

TOKEN : CMPLTRY
| SEQUENCE { addchild(root, newnode(SEQ, $1)); }
;

CMPLTRY : OPEN TOKEN_LIST CLOSE { root = $1; }
;

OPEN : LBRACKET OPENID LBRACKET SEQUENCE RBRACKET RBRACKET { node* branch = newnode(CMPL, $4); addchild(root, branch); $$ = root; root = branch; }
CLOSE : LBRACKET CLOSEID LBRACKET SEQUENCE RBRACKET RBRACKET 

%%
void yyerror(const char *fmt,...) {
    va_list ap;
  va_start(ap, fmt);
  vprintf(fmt, ap);
  va_end(ap);
  printf("\n");
  exit(1); 
 
}
int main() { 

  root = newnode(ROOT, NULL);
  root->x1 = WIDTH/2;
  root->y1 = HEIGHT/4;

  yyparse();

  svghead();
  walktree(root);
  svgtail();
}

