%{
#include "y.tab.h"
#include <string.h>
#define IDSTACKSIZE  1000
int yywrap(void);
char* extractc(char* str);
int yylex(void);
int id[IDSTACKSIZE] = {0};
int idptr = 0;
%}
%%
[0-9]+                   { return checkid(yytext); }
([aucg]","?" "?)+        { yylval.seq = extractc(yytext); return SEQUENCE; }
\[                       { return LBRACKET; }
\]                       { return RBRACKET; }
\n                       { ; }
.                        { ; }
%%
int yywrap(void)
{ return 1; }
char* extractc(char* str) {
  char* r = (char*) malloc(strlen(str)+1);
  int i=0;
  bzero(r, strlen(str)+1);
  while (str[0] != 0) {
    if (str[0] == 'a' || str[0] == 'u' || str[0] == 'c' || str[0] =='g') {
      r[i] = str[0];
      i++;
    }
    str++;
  }
  return r;
}
int checkid(char* str) {
  int newid = atoi(str);
  int i = 0;
  while ((i < idptr) && (id[i] != newid)) {
    i++;
  }

  if (i == idptr) { // push to stack
    if (idptr == IDSTACKSIZE) {
      printf("id stack too small.");
      exit(1);
    }

    id[idptr] = newid;
    idptr++;

    return OPENID;
  } else { // remove from stack
    idptr--;
    if (i < idptr) {
      id[i] = id[idptr];
    }
    return CLOSEID;
  }
}
