#include <stdio.h>
#include <string.h>

#define N 10

void pra(int* array)
{
  int i;
  for (i=0; i<N; i++)
    printf("%d ", array[i]);
  printf("\n");
}

int is_next_available(int i, int* blocked, int* visited)
{
  int c = i;
  do {
    c = (c + 1) % N;
  } while ((i != c) && ((blocked[c] > -1) || (visited[c] > -1)));

  return (i != c);
}

int next_available(int i, int* blocked, int* visited)
{
  int c = rand() % N;

  while ((c == i) || (blocked[c] > -1) || (visited[c] > -1)) {
    c = (c + 1) % N;
  }
  
  visited[c] = 1;
  return c;
}

int main()
{
  //                 0   1   2   3   4   5   6   7   8   9
  //                ok  ok  ok              ok      ok
  int visited[N] = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1};
  int blocked[N] = {-1, -1, -1,  4,  5,  0, -1,  4, -1,  0};

  printf("visited, blocked:\n");
  pra(visited);
  pra(blocked);

  printf("iterate: ");
  int i = 1;
  while (is_next_available(i, blocked, visited)) {
    printf("%d ", next_available(i, blocked, visited)); fflush(stdout);
  }
  printf("\n");

  return 0;
}
